-- This will load the config when loading Ved, or create it if it doesn't exist yet.

function saveconfig()
	love.filesystem.write("settings.lua", 's.customvvvvvvdir = "' .. s.customvvvvvvdir .. '" -- do not include the directory called "levels" here, nor a trailing (back)slash\r\ns.language = "' .. s.language .. '"\r\ns.dialoganimations = ' .. boolstring(s.dialoganimations) .. '\ns.allowlimitbypass = ' .. boolstring(s.allowlimitbypass) .. '\ns.flipsubtoolscroll = ' .. boolstring(s.flipsubtoolscroll) .. '')
end

function boolstring(thebool)
	if thebool == nil then
		return "nil"
	elseif thebool == true then
		return "true"
	else
		return "false"
	end
end

if love.filesystem.exists("settings.lua") then
	-- It exists
	
	s = {}
	s.customvvvvvvdir = ""
	s.language = "English"
	s.dialoganimations = true
	s.allowlimitbypass = false
	s.flipsubtoolscroll = false
	
	love.filesystem.load("settings.lua")()
else
	-- It doesn't exist, create it.
	print("Making new config file")
	
	s = {}
	s.customvvvvvvdir = ""
	s.language = "English"
	s.dialoganimations = true
	s.allowlimitbypass = false
	s.flipsubtoolscroll = false
	
	saveconfig()
end